package cs108;

import java.util.*;

public enum Card {
    SIX_OF_SPADE(Color.SPADE, Rank.SIX),
    SEVEN_OF_SPADE(Color.SPADE, Rank.SEVEN),
    EIGHT_OF_SPADE(Color.SPADE, Rank.EIGHT),
    NINE_OF_SPADE(Color.SPADE, Rank.NINE),
    TEN_OF_SPADE(Color.SPADE, Rank.TEN),
    JACK_OF_SPADE(Color.SPADE, Rank.JACK),
    QUEEN_OF_SPADE(Color.SPADE, Rank.QUEEN),
    KING_OF_SPADE(Color.SPADE, Rank.KING),
    ACE_OF_SPADE(Color.SPADE, Rank.ACE),

    SIX_OF_HEART(Color.HEART, Rank.SIX),
    SEVEN_OF_HEART(Color.HEART, Rank.SEVEN),
    EIGHT_OF_HEART(Color.HEART, Rank.EIGHT),
    NINE_OF_HEART(Color.HEART, Rank.NINE),
    TEN_OF_HEART(Color.HEART, Rank.TEN),
    JACK_OF_HEART(Color.HEART, Rank.JACK),
    QUEEN_OF_HEART(Color.HEART, Rank.QUEEN),
    KING_OF_HEART(Color.HEART, Rank.KING),
    ACE_OF_HEART(Color.HEART, Rank.ACE),

    SIX_OF_DIAMOND(Color.DIAMOND, Rank.SIX),
    SEVEN_OF_DIAMOND(Color.DIAMOND, Rank.SEVEN),
    EIGHT_OF_DIAMOND(Color.DIAMOND, Rank.EIGHT),
    NINE_OF_DIAMOND(Color.DIAMOND, Rank.NINE),
    TEN_OF_DIAMOND(Color.DIAMOND, Rank.TEN),
    JACK_OF_DIAMOND(Color.DIAMOND, Rank.JACK),
    QUEEN_OF_DIAMOND(Color.DIAMOND, Rank.QUEEN),
    KING_OF_DIAMOND(Color.DIAMOND, Rank.KING),
    ACE_OF_DIAMOND(Color.DIAMOND, Rank.ACE),

    SIX_OF_CLUB(Color.CLUB, Rank.SIX),
    SEVEN_OF_CLUB(Color.CLUB, Rank.SEVEN),
    EIGHT_OF_CLUB(Color.CLUB, Rank.EIGHT),
    NINE_OF_CLUB(Color.CLUB, Rank.NINE),
    TEN_OF_CLUB(Color.CLUB, Rank.TEN),
    JACK_OF_CLUB(Color.CLUB, Rank.JACK),
    QUEEN_OF_CLUB(Color.CLUB, Rank.QUEEN),
    KING_OF_CLUB(Color.CLUB, Rank.KING),
    ACE_OF_CLUB(Color.CLUB, Rank.ACE);

    public enum Color {
        SPADE("\u2660"), HEART("\u2661"), DIAMOND("\u2662"), CLUB("\u2663");

        public static final List<Color> ALL = List.of(values());
        public static final int COUNT = ALL.size();

        private final String asString;

        Color(String asString) {
            this.asString = asString;
        }

        @Override
        public String toString() {
            return asString;
        }
    }

    public enum Rank {
        SIX("6"), SEVEN("7"), EIGHT("8"), NINE("9"), TEN("10"), JACK("J"), QUEEN("Q"), KING("K"), ACE("A");

        public static final List<Rank> ALL = List.of(values());
        public static final int COUNT = ALL.size();

        private final String asString;

        Rank(String asString) {
            this.asString = asString;
        }

        @Override
        public String toString() {
            return asString;
        }
    }

    public static final List<Card> ALL = List.of(values());
    public static final int COUNT = ALL.size();

    public static final Map<Color, List<Card>> ALL_OF = computeAllOf();

    private static Map<Color, List<Card>> computeAllOf() {
        Map<Color, List<Card>> allOf = new HashMap<>();
        for (Color c : Color.ALL)
            allOf.put(c, new ArrayList<>());
        for (Card c : ALL)
            allOf.get(c.color).add(c);
        for (Map.Entry<Color, List<Card>> entry : allOf.entrySet())
            entry.setValue(List.copyOf(entry.getValue()));
        return Map.copyOf(allOf);
    }

    private final Color color;
    private final Rank rank;

    Card(Color color, Rank rank) {
        this.color = color;
        this.rank = rank;
    }

    public Color color() {
        return color;
    }

    public Rank rank() {
        return rank;
    }

    @Override
    public String toString() {
        return String.format("%s%s", color(), rank());
    }
}
